// SimULATIon.cpp
//
//////////////////////////////////////////////////////////////////////

#include "simulation.h"
#include "simset.h"
#include <string>
//#include "process.h"

//////////////////////////////////////////////////////////////////////
// EventNotice.cpp: implementation of the CEventNotice class.
//
//////////////////////////////////////////////////////////////////////

CEventNotice::CEventNotice (TIME time, CProcess * p)
{
  evTime = time;
  proc = p;
  SetName ();			// nastavi name objektu
}

CEventNotice::~CEventNotice ()
{
  this->Out ();			// pred svym zrusenim se vyradi ze seznamu
}

// zaradi pozadavek na casovou osu seznamu SQS
// before = true ... pred vsechny pozadavky se stejnym evTime
// before = false ... pred pozadavky s vestim evTime
void
CEventNotice::Rank (bool before)
{
  CEventNotice *p;

  p = (CEventNotice *) CProcess::SQS->First ();

  while ((p != NULL) && (p->evTime < evTime))
    p = (CEventNotice *) p->Suc ();

  if (!before)
    while ((p != NULL) && (p->evTime == evTime))
      p = (CEventNotice *) p->Suc ();

  SetName ();
  if (p != NULL)
    Precede (p);
//      else Into(CProcess.SQS);
  else
    Into (CProcess::SQS);
}

// vytvori pro polozku jmeno ve tvaru Event at ABC on Device XYZ
void
CEventNotice::SetName ()
{
  string text;			// pro sestaveni textu pro list
  char t[50];
  text = "Event at ";
  //gcvt (evTime, 10, t);
  sprintf(t, "%f", evTime);
  text += t;
  text += " on ";
  text += proc->GetName ();	// prida name planovaneho procesu
  CLinkage::SetName (text);	// nastavi name v Clinkage dle text 
}
